
MSG up@ - cell+ cell+ value #USER
\ A variable that holds the count of how many user variables are allocated.

0 value op_var
: up@+ ( n -- addr )
  up@  dup [ up@ ] literal = op_var and + + ;

: op-size ( -- n ) #USER [ MSG up@ - ] literal - ;
: op-buffer ( -- a ) op_var [ msg cell+ ] literal + ;
: op> ( a -- a' )
      dup op-buffer
      dup op-size + between if op_var - then ;
: >op ( a -- a' )
      dup  [ msg cell+ ] literal
      dup op-size + between if op_var + then ;

VOCABULARY USER-lib   USER-lib DEFINITIONS
\ Vocabulary that holds task versions of defining words.

: ALLOT         ( n -- )
\ Allocate space in the user area for a multi-tasking word.
       +to #USER
       ;

: CREATE        ( -- )
\ Define a word that returns the address of the next available user
\ memory location.
\   HEADER  DOUSER , #USER , ;
  CREATE #USER , does> @ up@+ ;

: VARIABLE      ( -- )
\ Define a task type variable. Similar to the old FIG version word USER.
                CREATE  1 cells ALLOT   ;

  cfa-func do-us-value!   -2 cells+ @ up@+  ! ;
  cfa-func do-us-value+!  -3 cells+ @ up@+ +! ;

: value-us        ( d1 -<name>- )
               VARIABLE do-us-value! , do-us-value+! ,
               does> @ up@+ @ ;

: defer-us     VARIABLE do-us-value! ,
               does> @ up@+ @ execute ( PERFORM) ;

FORTH DEFINITIONS

