\  VIRTUAL FORTH MACHINE                  Mihail 0. Maksimov
\+ IP-SOCK IP-SOCK @ CLOSESOCKET DROP
ANEW QUIT.F
NEEDS TASKER1.F
20000 CONSTANT ROM_SIZE
10000 CONSTANT RAM_SIZE

ALSO USER-LIB
VARIABLE #RAM
VARIABLE V_RP
VARIABLE V_IP
VARIABLE V_HANDLER
VARIABLE MINI-HANDLER
VARIABLE MYSELF
PREVIOUS

CREATE OP-BUFF 400 ALLOT
 OP-BUFF MSG - CELL+ TO OP_VAR
' W-PAUSE TO BIG-PAUSE
' NOOP    TO END-PAUSE

: RAM  #RAM @ ;

CREATE ROM ROM_SIZE RAM_SIZE + ALLOT

HERE RAM_SIZE - #RAM !

ROM ROM_SIZE + constant max_dyn
max_dyn 4000 - constant buf_dyn
buf_dyn value cur_dyn
CREATE CALL-TAB   400 CELLS ALLOT

0 VALUE V_LAST_CALL

: V>_  ROM + ;

: >V_  DUP RAM U<
       IF ROM - EXIT THEN
          RAM - ROM_SIZE + ;

DEFER V>   ' V>_ IS V>

DEFER VV>  ' V>_ IS VV>    \ FOR READ-ONLY

DEFER >V   ' >V_ IS >V


: "V>_   SWAP 2DUP +  V> DROP  V> SWAP ;
DEFER "V>  ' "V>_ IS "V>
: "VV>  SWAP 2DUP + VV> DROP VV> SWAP ;

: V_@ ( ADR -- N )
        V>  @ ;

: V_! ( N ADR -- )
        VV> ! ;

: V_+! ( N ADR -- )
        VV> +! ;

: V_C@ ( ADR -- C )
        V> C@ ;

: V_C! ( C ADR -- )
        VV> C! ;

: V_W@ ( ADR -- W )
        V> W@ ;

: V_W! ( W ADR -- )
        VV> W! ;

: V_2@ ( ADR -- N )
        V> 2@ ;

: V_2! ( N ADR -- )
        VV> 2! ;

: V_OFF ( ADR -- )
        VV> OFF ;

: V_ON ( ADR -- )
        VV> ON ;

ROM_SIZE VALUE VHERE

: VALLOT +TO VHERE ;
: VCREATE VHERE CONSTANT ;
: VVARIABLE VCREATE 0 VHERE V_! 1 CELLS VALLOT ;

VARIABLE *V_TYPE* ' TYPE *V_TYPE* !
VARIABLE *V_EMIT* ' EMIT *V_EMIT* !
VARIABLE *V_KEY*  ' KEY  *V_KEY*  !
VARIABLE *V_KEY?* ' KEY? *V_KEY?* !

: VV_TYPE    *V_TYPE* @ EXECUTE ;
: V_TYPE "V>  VV_TYPE ;
: V_EMIT     *V_EMIT* @ EXECUTE ;
0 VALUE V_LAST_KEY
: V_KEY? ( -- F )
        V_LAST_KEY IF TRUE EXIT THEN
         BEGIN
             *V_KEY?* @ EXECUTE dup 0=
             if  pause  EXIT
             THEN
             *V_KEY*  @ EXECUTE
             dup 0xa =
          WHILE   2DROP
          REPEAT  TO V_LAST_KEY
          ;
: V_KEY ( -- C )
 BEGIN V_KEY? UNTIL V_LAST_KEY 0 TO V_LAST_KEY ;
: V_SPACE  BL V_EMIT ;
: V_SPACES 0 ?DO V_SPACE LOOP ;

\ CREATE V_$CR 2 C, 13 C, 10 C,

 : V_CR   (  --  ) \         OUTPUT NEWLINE

\   0X0D V_EMIT 0X0A V_EMIT ;

 CRLF$ COUNT VV_TYPE ;

VCREATE V_TIB 180 VALLOT
V_TIB V> 180 BLANK
S"  : XXX CREATE , DOES> @ 0 DO I . I 3 = ?LEAVE LOOP ;  20 XXX YYY "
V_TIB V> SWAP CMOVE
VVARIABLE V_#TIB

: V_SOURCE ( -- ADR LEN )
\ RETURN ADDRESS AND COUNT OF THE INPUT STRING IN THE TEXT INPUT BUFFER.
        V_TIB V_#TIB V_@ ;

VVARIABLE V_>IN

: V_\           ( -- )
                V_SOURCE V_>IN V_! DROP ;

: V_PARSE         ( CHAR -- ADDR LEN )
                >R V_SOURCE "V> V_>IN V_@ /STRING
                2DUP R@ SKIP 2SWAP NIP OVER - V_>IN V_+!
                2DUP R> SCAN NIP -     DUP 1+ V_>IN V_+!
                SWAP >V SWAP ;


: V_(  ( -- )
 [CHAR] ) V_PARSE  2DROP ;

: V_.(  ( -- )

 [CHAR] ) V_PARSE V_TYPE ;

: V_/STRING  ( ADDR1 LEN1 N1 -- ADDR2 LEN2 )
 2DUP 2>R UMAX "VV> DROP 2R> /STRING ;
: -TRAILING  ( ADDR N1 -- ADDR N2 )
 "VV> -TRAILING  ;

: V_BRANCH     V_IP @
  DUP V_W@ dup V_IP !
  u< 0= if pause then ;

: V_?BRANCH
        IF   V_IP @ 1+ 1+
        ELSE V_IP @
         DUP V_W@ TUCK u< 0= if pause then
        THEN V_IP ! ;

VVARIABLE V_DP

: V_ALLOT V_DP V_+! ;

: VX,  V_DP V_@ V_W! 2 V_ALLOT ;

VVARIABLE  V_LAST

\ FLOW CONTROL

: V_HERE V_DP V_@ ;

: V_BEGIN ( -- N ) \ LEAVE THE ADR ON STACK FOR UNTIL AND AGAIN TO RESOLVE
       V_HERE ;

0 VALUE 'V_?BRANCH
0 VALUE 'V_BRANCH
0 VALUE 'V__OF
0 VALUE 'V__endcase
0 VALUE 'V_(C")
0 VALUE 'V_(S")
0 VALUE 'V_(.")
0 VALUE 'V_DOLIT
0 VALUE 'V_!
0 VALUE 'V_(DOES>)
0 VALUE 'V_(ABORT")
0 VALUE 'V_(DO)
0 VALUE 'V_(?DO)
0 VALUE 'V_(LOOP)
0 VALUE 'V_(+LOOP)
0 VALUE 'V_DOCON
0 VALUE 'V_DOVAL
0 VALUE 'V_DO2CON
0 VALUE 'V_DOVAR
0 VALUE 'V_DOVOC
0 VALUE 'v_COMPILE

VVARIABLE V_RP0
ROM_SIZE RAM_SIZE + V_RP0 V_!
: V_RP@ V_RP @ ;
: V_RP! V_RP ! ;


: V_R@  V_RP @ V_@  ;

: V_R>DROP CELL V_RP +! ;

: V_R>  V_R@ V_R>DROP ;

: V_>R  -CELL V_RP +! V_RP @ V_! ;

: V_2R@  V_RP @ V_2@  ;

: V_2R>DROP 2 CELLS V_RP +! ;

: V_2R>  V_2R@ V_2R>DROP ;

: V_2>R -2 CELLS V_RP +! V_RP @ V_2! ;

: V_>CATCH
    SP@  V_>R
    V_HANDLER @ V_>R
    V_RP@  V_HANDLER !
;

\ 0 VALUE V_?THROW

: V_CATCH>
\    FALSE TO V_?THROW
    V_R> V_HANDLER !
    V_R> DROP
    0
     ;

: MINI-CATCH
      RP@ MINI-HANDLER !
      EXECUTE ;
: MINI-THROW         ( N -- )
      MINI-HANDLER @ RP!
;

: V_EXIT  V_R>  V_IP ! ;

: V_THROW         ( N -- )
    ?DUP
    IF      V_HANDLER @ V_RP!
            V_R> V_HANDLER !
            V_R> SWAP >R
            SP! DROP  R>
\            TRUE TO V_?THROW
             V_EXIT
            MINI-THROW
    THEN ;

: V_ABORT         ( -- )
    -1 V_THROW ;

: V_UNTIL ( N -- )
       'V_?BRANCH VX,  VX, ;


: V_AGAIN ( N -- )
       'V_BRANCH VX,  VX, ;

: V_IF ( -- ADR )
        'V_?BRANCH VX, V_HERE
        0 VX, ;

: V_AHEAD ( -- N )
        'V_BRANCH VX, V_HERE
        0 VX, ;

: V_REPEAT ( ADR -- )
        V_AGAIN V_HERE SWAP V_W! ;

: V_THEN ( ADR -- )
        V_HERE SWAP V_W! ;

: V_ELSE ( ADR -- ADR' )
        V_AHEAD SWAP V_THEN ;

: V_WHILE ( ADR -- ADR' )
        V_IF SWAP ;

: V_?pairs  ( n1 n2 -- )
   xor IF S" conditionals not paired" vv_TYPE V_abort THEN
 ;


: V_C,  V_HERE V_C! 1    V_ALLOT ;
: V_W,  V_HERE V_W! 2    V_ALLOT ;
: V_,   V_HERE V_!  CELL V_ALLOT ;

\ STRING

: V_PLACE  V> >R "V> R> PLACE ;

: V_COUNT  V> COUNT >R >V R> ;


: V_(C")         ( -- )
            V_IP @ DUP V_C@ char+ V_IP +!  ;

: V_(S")         ( -- )
          V_(C") V_COUNT ;

: V_(.")  V_(S") V_TYPE ;

: V_(ABORT")      ( F -- )
    V_(S") ROT
    IF      V_TYPE
            -2  V_THROW
    THEN    2DROP ;

: V_S"ABORT  VV_TYPE V_ABORT ;


: 2+ 1+ 1+ ;

: V_,"            ( -- )
                [CHAR] " V_PARSE TUCK V_HERE V_PLACE ( LEN )
                1+ V_ALLOT ;

: V_C" ( -- \ <STRING> )
      'V_(C") VX, V_," ;



: vDynAlloc ( n -- addr )
   200 /mod
   if s" Can't allocate a dynamic string this large" V_S"ABORT
   then
   cur_dyn bounds
   over max_dyn u>
   if  nip buf_dyn bounds
   then dup +to cur_dyn -
;

VVARIABLE V_STATE

: V_S" ( -- \ <STRING> )
     v_state v_@
     if  'V_(S") VX, V_,"
     else [char] " v_parse
          "V> dup 1+ vDynAlloc
           DUP>R place r>
           COUNT >r >v r>
     then
;

: V_." ( -- \ <STRING> )
      'V_(.") VX, V_," ;

: ">$           ( A1 N1 -- A2 )
                DROP 1- ;

: 2- 1- 1- ;
: V_>BODY  ( CFA -- PFA ) 1+ 1+ ;
: V_BODY>  ( PFA -- CFA ) 1- 1- ;
: V_LINK>N ( LFA -- NFA ) 1+ 1+ ;
: V_N>LINK ( NFA -- LFA ) 1- 1- ;

: V_NAME>
        V_COUNT   $1F  AND   + ;

: V_(>NAME) ( CFA VOC -- NFA F )
        V_W@
        BEGIN ?DUP
        WHILE 2DUP V_LINK>N V_NAME> =
                IF V_LINK>N SWAP DROP TRUE EXIT
                THEN DUP V_W@ TUCK u> 0= if pause then
        REPEAT
        0 SWAP DROP FALSE ;

VVARIABLE V_VOC-LINK         \ LINKED LIST OF VOCABULARIES, IN KERNEL

: V_>NAME ( CFA -- NFA | 0 ) \ SEARCH THROUGH ALL VOCABULARIES
        V_VOC-LINK ( CFA ADR )
        BEGIN DUP V_@ TUCK u> 0= if pause then  ?DUP
        WHILE 2DUP CELL- V_@ V_(>NAME)
                IF >R 2DROP R> EXIT
                ELSE DROP
                THEN
        REPEAT DROP 0 ;

: V_>LINK ( CFA -- LFA )
        V_>NAME 2- ;


: V_LINK> ( LFA -- CFA )
        V_LINK>N V_NAME> ;

: V_RECURSE ( -- )
      V_LAST V_@ V_NAME> VX, ;

0 VALUE CUR_CFA

: V_DOCOL V_IP @ V_>R CUR_CFA V_>BODY V_IP ! ;

: V_EXECUTE
    DUP TO CUR_CFA V_W@ DUP
    V_LAST_CALL U<
    IF    CALL-TAB +CELLS PERFORM \ @ DUP >NAME  .ID  EXECUTE
    ELSE DROP V_IP @ V_>R CUR_CFA DUP V_W@ V_IP ! V_>BODY
    THEN ( ." V_IP=" V_IP @ . ) ;

: V_EXEC  DUP TO CUR_CFA V_W@ DUP
\    80 ?CR
    V_LAST_CALL U<
    IF   CELLS CALL-TAB + @ ( DUP >NAME  .ID ) EXECUTE \  PERFORM
    ELSE DROP V_IP @ V_>R CUR_CFA DUP V_W@ V_IP ! V_>BODY
    THEN ( ." V_IP=" V_IP @ . ) ;

: V_@EXECUTE V_@ V_EXECUTE ;

: V_WORD
        V_PARSE   V_HERE  V_PLACE V_HERE ;

: V_?MISSING      ( F -- )
        IF V_HERE V_COUNT V_TYPE S"  IS UNDEFINED" V_S"ABORT THEN ;

VARIABLE TMP


: V_FIND-A-VOC ( ADR VOC-ADDR -- ADR FALSE | NFA TRUE)
        SWAP V_COUNT "V> 2>R
        BEGIN DUP V_W@ TUCK u> 0= if pause then
              DUP          \ LFA LFA
        WHILE DUP V_LINK>N      \ LFA NFA
              V_COUNT $1F AND "V> 2R@ COMPARE 0=
              IF 2R> 2DROP V_LINK>N TRUE EXIT
              THEN
        REPEAT DROP 2R> DROP  1- FALSE ;

16 CONSTANT V_#VOCS
VCREATE V_CONTEXT V_#VOCS CELLS VALLOT
V_CONTEXT V> V_#VOCS CELLS ERASE
: V_UPPER "V> UPPER ;
: V_FIND ( ADR -- ADR FALSE | XT 1 | XT -1 )
        DUP V_COUNT V_UPPER V_CONTEXT
        BEGIN 2DUP V_@ ?DUP
        WHILE V_FIND-A-VOC
                IF NIP NIP DUP V_NAME>
                   SWAP V_C@ 0X80 AND 0= 1 OR  EXIT
                ELSE DROP
                THEN CELL+
        REPEAT 2DROP FALSE ;

: V_PAD V_HERE 100 + ;

: V_TOKEN ( -- ADR | <STRING> )
        BL V_PARSE 31 MIN
        V_PAD V_PLACE
        V_PAD DUP V_COUNT V_UPPER
        ;


: V_DEFINED       ( -- STR 0 | CFA FLAG )
                BL V_WORD V_FIND ;

: V_'             ( -- CFA )
    V_DEFINED 0= V_?MISSING ;

: V_DOLIT  ( -- N )
        V_IP @ V_@ CELL V_IP +! ;


: V_LIT 'V_DOLIT VX, V_, ;
: V_2LITERAL      ( d1 -- )
       swap V_LIT V_LIT ;


: V_['] V_' V_LIT ;

: v_[COMPILE]     ( -<name>- )
        V_' VX, ;

: v_to
    v_' v_>body
    state @ if v_lit 'v_! vx,  else v_! then ; immediate


: v_COMPILE     ( -<name>- )
        V_IP @ V_w@ 2 V_IP +! VX, ;

: v_POSTPONE      ( -<name>- )
                v_DEFINED DUP 0= v_?MISSING
                0< IF 'v_COMPILE VX,  THEN
                VX, ;

\ CREATE DOES>


: V_?UNIQUE
        DUP   V_FIND
        IF V_CR S"  REDEF " VV_TYPE
                OVER   V_COUNT   V_TYPE
        THEN DROP   ;

: V_CMOVE ( A1 A2 L -- )
  "VV> ROT OVER "V> DROP -ROT CMOVE ;

: V_CMOVE> ( A1 A2 L -- )
  "VV> ROT OVER "V> DROP -ROT CMOVE> ;

: V_MOVE ( A1 A2 L -- )
  "VV> ROT OVER "V> DROP -ROT  MOVE  ;

: V_FILL      ( A L C -- )
      >R  "VV> R> FILL ;
: V_ERASE     ( A L -- )
          "VV>  ERASE  ;
: V_BLANK     ( A L -- )
          "VV>  BLANK  ;
VVARIABLE V_CURRENT

: v_GET-CURRENT   ( -- wid )
                v_CURRENT v_@ ;
: v_SET-CURRENT   ( wid -- )
                v_CURRENT v_! ;


: V_$,N
        DUP   V_C@
        IF V_?UNIQUE
                V_CURRENT   V_@   V_W@   V_W,
                V_HERE   V_LAST   V_!
                DUP   V_C@    1+  >R
                V_HERE   R@   V_CMOVE   R>   V_ALLOT
                EXIT
        THEN
        S" NAME" V_S"ABORT
;

: V_OVERT
        V_LAST V_@ 2- V_CURRENT V_@ V_! ;

: V_IMMEDIATE
        0X80 V_LAST V_@ V_@ OR
        V_LAST V_@ V_! ;


: V_DOVAR CUR_CFA V_>BODY ;

: V_DOCON  CUR_CFA V_>BODY V_@ ;
: V_DOVAL  V_DOCON ;

: V_DO2CON CUR_CFA V_>BODY V_2@ ;

: V_CREATE ( -- \ <STRING> )
   V_TOKEN V_$,N V_OVERT
   'V_DOVAR VX, ;

: V_(DOES>)
        V_IP @  V_LAST V_@ V_NAME>  V_W!  V_EXIT  ;


: V_DOES> ( -- )
        'V_(DOES>) VX, ;

:  V_VARIABLE V_CREATE   0 V_, ;
: V_2VARIABLE V_VARIABLE 0 V_, ;


: V_CONSTANT V_TOKEN V_$,N V_OVERT 'V_DOCON VX, V_, ;

: V_VALUE V_TOKEN V_$,N V_OVERT 'V_DOVAL VX, V_, ;

: V_2CONSTANT V_TOKEN V_$,N V_OVERT 'V_DO2CON VX,
   v_here v_2! 2 cells v_allot  ;

: V_ABORT"        ( -- )
    'V_(ABORT") VX,  V_,"  ;

: V_?CONDITION    ( F -- )
              TRUE = ?EXIT S" CONDITIONALS WRONG" *V_TYPE* PERFORM
                V_ABORT  ;

: V_>MARK         ( -- ADDR ) \ FORWARD JUMP
                V_HERE 0 VX, ;

: V_>RESOLVE      ( ADDR -- ) \ FULFIL FORWARD JUMP
                V_HERE SWAP V_W! ;

: V_<MARK         ( -- ADDR )
                V_HERE ;

: V_<RESOLVE      ( ADDR -- )
                VX, ;

: V_?>MARK        ( -- F ADDR )
                TRUE V_>MARK   ;

: V_?>RESOLVE     ( F ADDR -- )
                SWAP  V_?CONDITION V_>RESOLVE ;

: V_?<MARK        ( -- F ADDR )
                TRUE V_<MARK   ;

: V_?<RESOLVE     ( F ADDR -- )
                SWAP V_?CONDITION V_<RESOLVE  ;

: NR@ ( N -- N' )  \ TAKE NTH VALUE FROM RETURN STACK
        CELLS V_RP@ + V_@ ;

: NR! ( N1 N2 -- )
        CELLS V_RP@ + V_! ;

\  STRUCTURE: (LOOP) ADDR-IF-LOOP
\ RETURN STACK: HIGH-LIMIT CURRENT-COUNT NEXT-ADDR
\               1 NR@      0 NR@         R@
: SIGN-CHANGE? ( N1 N2 -- F )
        0< SWAP 0< XOR ;

: v_UNLOOP 3 CELLS V_RP +! ;

: V_(LOOP)  \ RUN TIME CODE FOR LOOP
        V_IP @
        0 NR@ DUP 1+ DUP 0 NR! SIGN-CHANGE?   \ COMPARE CURRENT WITH HIGH LIMIT
        IF   v_UNLOOP 2+
        ELSE V_W@ pause
        THEN V_IP ! ;

: V_(+LOOP) ( N -- )
        V_IP @
        0 NR@ ROT OVER + DUP 0 NR! SIGN-CHANGE?
        IF   v_UNLOOP 2+
        ELSE V_W@ pause
        THEN V_IP ! ;



\ DO LOOP STRUCTURE
\ RETURN STACK: (DO)+CELL H+80000000 L-(H+80000000)
\ (DO) ADR-(LOOP)+2CELLS ... (LEAVE) ...... (LOOP) ADR-(DO)+2CELLS


: V_(DO) ( H L -- )
        V_IP @ V_>R
        SWAP 0X80000000 + DUP V_>R  ( L H+80000000)
        - V_>R
        V_IP @ 2+ V_IP ! ;


: V_DO    ( -- F ADDR )
        'V_(DO) VX, V_?>MARK ;


: V_(?DO) ( H L -- )
        2DUP =
        IF 2DROP V_BRANCH
        ELSE     V_(DO)
        THEN ;

: V_?DO ( --  )
        'V_(?DO) VX, V_?>MARK ;

: V_LEAVE ( -- )
        V_2R>DROP V_R> V_W@ V_IP ! ;

: V_?LEAVE ( F -- )
        IF V_LEAVE
        THEN ;

: V_LOOP ( -- )
        'V_(LOOP) VX, 2DUP 2+ V_?<RESOLVE  V_?>RESOLVE ;


: V_+LOOP
        'V_(+LOOP) VX, 2DUP 2+ V_?<RESOLVE V_?>RESOLVE ;

: V_I ( -- N )
        0 NR@ 1 NR@ + ;

: V_J ( -- N )
        3 NR@ 4 NR@ + ;

: V_K ( -- N )
        6 NR@ 7 NR@ + ;

: V_[ FALSE V_STATE V_! ;
: V_] TRUE  V_STATE V_! ;

: V_?comp ;
: V__of   OVER = if drop 2 v_ip +! else v_BRANCH then ;
: V_case   V_?comp  0 ;
: V_of     V_?comp  'V__of VX, V_>mark 4 ; immediate
: V_endof  V_?comp  4 V_?pairs  'V_BRANCH VX,
            V_>mark swap v_>resolve  5 ; immediate

: V_endcase  V_?comp  'V__endcase VX,
           begin  ?dup
           while  5 V_?pairs  V_>resolve PAUSE
           repeat ;

VVARIABLE V_BASE

: V_NUMBER?  "V> v_base v_@ base ! NUMBER? ;

: V_NUMBER      ( STR -- D )
                V_COUNT "V>
                v_base v_@ base !
                 NUMBER? 0= V_?MISSING ;

: V_NUMBER,      ( D -- )
                DOUBLE? 0= IF DROP THEN
                V_STATE V_@
                IF      DOUBLE? IF  SWAP  V_LIT THEN
                        V_LIT
                THEN ;

DECIMAL

VVARIABLE V_HLD

: V_HOLD ( CHAR -- ) \ PUT CHAR TO HLD
        V_HLD V_@ 1-
        DUP V_HLD V_! V_C! ;

: V_<#            ( -- )
                V_PAD V_HLD V_! ;

: V_#>            ( D1 -- ADDR LEN )
                2DROP  V_HLD V_@ V_PAD OVER - ;

: V_SIGN          ( F1 -- )
                0< IF  [CHAR] - V_HOLD  THEN ;

: V_DIGIT ( N -- CHAR )
        9 OVER <  \ IF > 9 THEN SKIP 7 ASCII CODE BETWEEN 9 AND A
        7 AND +
        '0'  + ;

: V_EXTRACT  ( D BASE -- D' CHAR )
   DUP 0= ABORT" "  UM/MOD  0  ROT V_DIGIT  ;

: V_#  ( D -- D' )  \ EXTRACT ONE DIGIT
        V_BASE V_@ V_EXTRACT V_HOLD ;

: V_HEX     0X10 V_BASE V_! ;
: V_DECIMAL   10 V_BASE V_! ;
: V_#S     ( D1 -- D2 )          BEGIN  V_#  2DUP OR 0= UNTIL ;
: V_(D.)   ( D -- ADDR LEN )     TUCK DABS V_<# V_#S ROT V_SIGN V_#> ;
: V_D.     ( D -- )              V_(D.) V_TYPE V_SPACE ;
: V_D.R    ( D W -- )            >R V_(D.) R> OVER - 0 MAX
         V_SPACES V_TYPE ;
: V_.      ( N -- )              S>D  V_D. ;
: V_.R     ( N W -- )            >R  S>D  R>  V_D.R ;
: V_U.     ( U -- )              0 V_D. ;
: V_U.R    ( U W -- )            0 SWAP V_D.R ;
: V_H.     ( U -- )              V_BASE V_@ SWAP  V_HEX V_U.  V_BASE V_! ;
: V_?      ( ADDR -- )           V_@ V_. ;

\ VOC STRUCTURE
\ 1 CELL            STORE LAST LFA OF THIS VOCUBALARY
\ 1 CELL            VOC LINK

: V_LINK,  ( ADDR -- ) V_HERE OVER V_@ V_, SWAP V_! ;
: V_DOVOC V_DOCON V_CONTEXT V_! ;
: V_VOCABULARY    ( -- )
       V_HERE  0  V_,
       V_CREATE -2 V_ALLOT 'V_DOVOC VX,  V_,
       V_VOC-LINK V_LINK,
                 ;

: V_DEFINITIONS   ( -- )
                V_CONTEXT V_@ V_CURRENT V_!   ;


VVARIABLE V_VROOT
VVARIABLE V_VFORTH

: V_ROOT  V_VROOT    V_CONTEXT V_!  ;
: V_FORTH V_VFORTH   V_CONTEXT V_!  ;


: V_ALSO          ( -- )
                V_CONTEXT DUP CELL+  V_#VOCS 1- CELLS V_MOVE  ;

: V_ONLY          ( -- )
                V_CONTEXT V_#VOCS CELLS V_ERASE  V_ROOT V_ALSO ;

: V_PREVIOUS      ( -- )
                V_CONTEXT DUP CELL+ SWAP  V_#VOCS CELLS V_MOVE
                V_CONTEXT V_@ 0=
                IF    V_ROOT
                THEN ;

0 V_VOC-LINK V_!
0 V_,

: #BUILD:
        BL WORD >V V_$,N V_OVERT
        VX,
;
: BUILD>
        CALL-TAB V_LAST_CALL CELLS+ !
        V_LAST_CALL DUP 1+ TO V_LAST_CALL
        #BUILD:
;

: V_VOC>VCFA 2- ;

: V_.ID ( NFA -- )
        V_COUNT 31 AND V_TYPE
;

: V_.NAME ( CFA -- )
        V_>NAME V_.ID ;

: V_.VOC  ( VOC -- )
        >R  V_VOC-LINK
        BEGIN DUP V_@ TUCK u> 0= if pause then
         ?DUP
        WHILE DUP CELL- V_@ R@ =
              IF DUP CELL- V_VOC>VCFA V_.NAME V_SPACE
              THEN
        REPEAT  R>DROP
;
: V_ORDER         ( -- )
                V_CR S" CONTEXT: " VV_TYPE
                V_CONTEXT
                V_#VOCS 0
                DO      DUP V_@ ?DUP
                        IF V_.VOC
                        THEN    CELL+
                LOOP    DROP
                V_CR S" CURRENT: " VV_TYPE
                V_CURRENT V_@   V_.VOC    ;

: V_VOCS          ( -- )
        V_CR V_VOC-LINK
        BEGIN DUP V_@ TUCK u> 0= if pause then
              ?DUP
        WHILE DUP CELL- V_VOC>VCFA V_.NAME V_SPACE
        REPEAT ;

V_ROOT V_ALSO V_DEFINITIONS

  ' V_FORTH  BUILD> FORTH
  V_VFORTH V_,
  V_VOC-LINK V_LINK,

  ' V_ROOT  BUILD> ROOT
  V_VROOT  V_,
  V_VOC-LINK V_LINK,

  ' V_ALSO  BUILD> ALSO

V_FORTH V_ALSO V_DEFINITIONS

' V_VOCABULARY  BUILD> VOCABULARY
' V_DEFINITIONS BUILD> DEFINITIONS

' V_VOC-LINK BUILD> VOC-LINK

' V_?BRANCH BUILD> ?BRANCH
V_HERE 2- TO 'V_?BRANCH

' V_BRANCH  BUILD> BRANCH
V_HERE 2- TO 'V_BRANCH

' V__OF  BUILD> _OF
V_HERE 2- TO 'V__OF

' DROP   BUILD> _ENDCASE
V_HERE 2- TO 'V__ENDCASE

' V_(C") BUILD> (C")
V_HERE 2- TO 'V_(C")

' V_(S") BUILD> (S")
V_HERE 2- TO 'V_(S")

' V_(.") BUILD> (.")
V_HERE 2- TO 'V_(.")

' V_DOLIT BUILD> DOLIT
V_HERE 2- TO 'V_DOLIT

' V_(DOES>) BUILD> (DOES>)
V_HERE 2- TO  'V_(DOES>)

' V_(ABORT") BUILD> (ABORT")
V_HERE 2- TO  'V_(ABORT")

' V_(DO)  BUILD> (DO)
V_HERE 2- TO 'V_(DO)

' V_(?DO)  BUILD> (?DO)
V_HERE 2- TO 'V_(?DO)

' V_(LOOP) BUILD> (LOOP)
V_HERE 2- TO 'V_(LOOP)

' V_(+LOOP) BUILD> (+LOOP)
V_HERE 2- TO 'V_(+LOOP)


' BL  BUILD> BL
V_HERE 2- CONSTANT 'V_BL

' V_WORD BUILD> WORD
V_HERE 2- CONSTANT 'V_WORD

' DUP BUILD> DUP
V_HERE 2- CONSTANT 'V_DUP

' ?DUP BUILD> ?DUP
V_HERE 2- CONSTANT 'V_?DUP

' V_C@ BUILD> C@
V_HERE 2- CONSTANT 'V_C@

' V_FIND BUILD> FIND
V_HERE 2- CONSTANT 'V_FIND

' V_DEFINED BUILD> DEFINED
V_HERE 2- CONSTANT 'V_DEFINED

' V_STATE BUILD> STATE
V_HERE 2- CONSTANT 'V_STATE

' = BUILD> =
V_HERE 2- CONSTANT 'V_=

' VX, BUILD> COMPILE,
V_HERE 2- CONSTANT 'V_COMPILE,

' V_EXECUTE BUILD> EXECUTE
V_HERE 2- CONSTANT 'V_EXECUTE

' V_EXEC BUILD> EXEC
V_HERE 2- CONSTANT 'V_EXEC

' ?STACK BUILD> ?STACK
V_HERE 2- CONSTANT 'V_?STACK

' V_NUMBER BUILD> NUMBER
V_HERE 2- CONSTANT 'V_NUMBER

' V_NUMBER, BUILD> NUMBER,
V_HERE 2- CONSTANT 'V_NUMBER,

' DROP BUILD> DROP
V_HERE 2- CONSTANT 'V_DROP

' V_EXIT BUILD> EXIT
V_HERE 2- CONSTANT 'V_EXIT

' V_@ BUILD> @
V_HERE 2- CONSTANT 'V_@

' V_! BUILD> !
V_HERE 2- TO 'V_!
' V_+!  BUILD> +!
' V_C!  BUILD> C!
' V_W@  BUILD> W@
' V_W!  BUILD> W!
' V_2@  BUILD> 2@
' V_2!  BUILD> 2!
' V_ON  BUILD> ON
' V_OFF BUILD> OFF


' NOOP BUILD> NOOP
V_HERE 2- CONSTANT 'V_NOOP

V_LAST_CALL CONSTANT 'V_DOCOL
' V_DOCOL BUILD> INTERPRET    ( -- )
V_HERE 2- CONSTANT 'V_INTERPRET
        V_BEGIN 'V_BL VX, 'V_WORD VX,  'V_DUP VX, 'V_C@ VX,
        V_WHILE 'V_FIND VX,   'V_?DUP VX,
              V_IF   'V_STATE VX, 'V_@ VX,  'V_= VX,
                      V_IF   'V_COMPILE, VX,
                      V_ELSE  'V_EXECUTE VX, \ 'V_?STACK VX,
                      V_THEN
              V_ELSE 'V_NUMBER VX,  'V_NUMBER, VX,
              V_THEN
        V_REPEAT 'V_DROP VX, 'V_EXIT VX,


: V_ACCEPT ( C-ADDR +N -- +N' ) \ GET LINE FROM TERM'L
    BL V_EMIT 8 V_EMIT  \ FOR CR DO
    "V>
   OVER + 1- OVER      \ SA EA A
   BEGIN V_KEY           \ SA EA A C
   DUP 0X0D <> WHILE
       DUP 27 = IF  DROP DUP C@ V_EMIT   ELSE
       DUP V_EMIT
       DUP 8  = IF  BL V_EMIT 8 V_EMIT
                    DROP 2- >R OVER 1- R> UMAX ELSE
       DUP 9  = IF  DROP DUP 8 BLANK
                    >R OVER R>    \ SA EA SA A
                    SWAP OVER -   \ SA EA SA A-SA
                    8 / 1+ 8 * +  ELSE
        OVER C! THEN THEN
                THEN 1+ OVER UMIN  \ SA EA A
   REPEAT                          \ SA EA A C
   DROP NIP SWAP - ;

VVARIABLE  V_SPAN

: v_EXPECT        ( a1 n1 -- )            \ accept the text
                v_accept v_span v_! ;

\ VCREATE V_(SOURCE) 2 CELLS VALLOT

: V_QUERY         ( -- )          \ ACCEPT A LINE OF INPUT FROM THE USER TO TIB
                V_TIB 180 V_ACCEPT V_#TIB V_!
                0 V_>IN V_!
                ;

: V_QUERY-INTERPRET   ( -- )
        V_QUERY V_SPACE 'V_INTERPRET V_EXECUTE ;

: V_REFILL V_CR V_QUERY TRUE ;

' V_REFILL BUILD> REFILL

\ : REFILL CR QUERY TRUE ;

' V_QUERY-INTERPRET BUILD> QUERY-INTERPRET
V_HERE 2- CONSTANT 'V_QUERY-INTERPRET

: V_OK.
     V_STATE V_@ 0=
     IF    S"  OK" VV_TYPE
           DEPTH .SMAX @ UMIN 0
           ?DO  [CHAR] . V_EMIT  LOOP
     THEN
;

' V_OK. BUILD> OK.
V_HERE 2- CONSTANT 'V_OK.


' V_>CATCH BUILD> >CATCH
V_HERE 2- CONSTANT 'V_>CATCH

' V_CATCH> BUILD> CATCH>
V_HERE 2- CONSTANT 'V_CATCH>

'V_DOCOL #BUILD: CATCH  ( CFA -- FLAG )
V_HERE 2- CONSTANT 'V_CATCH
    'V_>CATCH   VX,
    'V_EXECUTE  VX,
    'V_CATCH>   VX,
    'V_EXIT     VX,

' V_RP0 BUILD> RP0
V_HERE 2- CONSTANT 'V_RP0

' V_RP! BUILD> RP!
V_HERE 2- CONSTANT 'V_RP!

' V_[ BUILD> [     V_IMMEDIATE
V_HERE 2- CONSTANT 'V_[

' V_] BUILD> ]
V_HERE 2- CONSTANT 'V_]

' V_CR BUILD> CR
V_HERE 2- CONSTANT 'V_CR

' 0= BUILD> 0=
V_HERE 2- CONSTANT 'V_0=

' 0= BUILD> NOT
' >= BUILD> >=
' <= BUILD> <=


' 1+ BUILD> 1+
V_HERE 2- CONSTANT 'V_1+

' RESET-STACKS BUILD> RESET-STACKS
V_HERE 2- CONSTANT 'V_RESET-STACKS

: V_MESSAGE
 S" ERROR # " VV_TYPE
 V_. ;

' V_MESSAGE BUILD> MESSAGE
V_HERE 2- CONSTANT 'V_MESSAGE

: V_TST cr ." V_TST" .s ;

' V_TST BUILD> TST
V_HERE 2- CONSTANT 'V_TST

'V_DOCOL #BUILD: QUIT
V_HERE 2- CONSTANT 'V_QUIT

     'V_RP0 VX, 'V_@ VX, 'V_RP! VX,
      V_BEGIN   'V_[ VX,
             V_BEGIN  'V_CR VX,  'V_QUERY-INTERPRET V_LIT 'V_CATCH VX,
                     'V_?DUP VX, 'V_0= VX,
             V_WHILE  'V_OK. VX,
             V_REPEAT
        'V_DUP VX, 'V_1+ VX,  \ NO MESSAGE ON ABORT
        V_IF   'V_MESSAGE VX,
        V_THEN
        'V_RESET-STACKS  VX,  \ RESET THE STACKS
     V_AGAIN
/*
   OSTPONE [
   BEGIN
     REFILL
   WHILE
     ['] INTERPRET  CATCH
     CASE
        0 OF STATE @ 0= IF ." OK" THEN CR  ENDOF
       -1 OF ( ABORTED) ENDOF
       -2 OF ( DISPLAY  MESSAGE FROM ABORT" ) ENDOF
       ( DEFAULT ) DUP ." EXCEPTION # "  .
     ENDCASE
   REPEAT BYE
;

*/
: V_MOD DUP 0= ABORT" " MOD ;
: V_M*/ DUP 0= ABORT" " M*/ ;
: v_/MOD DUP 0= ABORT" " /MOD ;
: v_UM/MOD DUP 0= ABORT" " UM/MOD ;
: V_/ DUP 0= ABORT" " / ;
: V_*/ DUP 0= ABORT" " */ ;
: V_*/MOD DUP 0= ABORT" " */ ;
' +        BUILD> +
' -        BUILD> -
' *        BUILD> *
' V_/      BUILD> /
' V_*/  BUILD> */
' V_MOD       BUILD> MOD
' V_*/MOD       BUILD> */MOD
' V_UM/MOD      BUILD> UM/MOD
' 1-    BUILD> 1-
' 1+    BUILD> 1+
' CELL+ BUILD> CELL+
' CELLS BUILD> CELLS
' CELL- BUILD> CELL-

' V_HEX    BUILD> HEX
: V_EXTRACT  ( D BASE -- D' CHAR )
   DUP 0= ABORT" "  UM/MOD  0  ROT V_DIGIT  ;

' V_BASE   BUILD> BASE

' V_#      BUILD> #
' V_HLD BUILD> HLD
' V_HOLD        BUILD> HOLD
' V_<#  BUILD> <#
' V_#>  BUILD> #>
' V_SIGN        BUILD> SIGN
' V_DIGIT       BUILD> DIGIT

' V_#S     BUILD> #S
' V_(D.)   BUILD> (D.)
' V_D.     BUILD> D.
' V_D.R    BUILD> D.R
' V_.      BUILD> .
' V_.R     BUILD> .R
' V_U.     BUILD> U.
' V_U.R    BUILD> U.R
' V_H.     BUILD> H.
' V_?      BUILD> ?
' V_'      BUILD> '

: v_:NONAME
   V_HERE 'V_DOCOL VX, V_] ;

: V_: ( -- \ <STRING> )
   V_TOKEN V_$,N 'V_DOCOL VX, V_] ;

: V_; 'V_EXIT VX, V_[  V_OVERT ;

' v_:NONAME  BUILD> :NONAME
' V_:      BUILD> :
' V_;      BUILD> ;  V_IMMEDIATE

V_LAST_CALL TO 'V_DOCON
' V_DOCON BUILD> DOCON

V_LAST_CALL TO 'V_DOVAL
' V_DOVAL BUILD> DOVAL

V_LAST_CALL TO 'V_DO2CON
' V_DO2CON BUILD> DO2CON

V_LAST_CALL TO 'V_DOVAR
' V_DOVAR BUILD> DOVAR

V_LAST_CALL TO 'V_DOVOC
' V_DOVOC BUILD> DOVOC

V_LAST_CALL TO 'v_COMPILE
'v_COMPILE BUILD> v_COMPILE


' V_CONSTANT   BUILD> CONSTANT
' V_VALUE       BUILD> VALUE
' V_2CONSTANT   BUILD> 2CONSTANT
' V_DOES>      BUILD> DOES>  V_IMMEDIATE
' V_VARIABLE   BUILD> VARIABLE
' V_2VARIABLE   BUILD> 2VARIABLE
' V_CREATE     BUILD> CREATE

: V_H.N          ( N1 N2 -- )    \ DISPLAY N1 AS A HEX NUMBER OF N2 DIGITS
                V_BASE V_@ >R V_HEX >R
                0 V_<# R> 0 ?DO V_# LOOP V_#> V_TYPE
                R> V_BASE V_! ;

: V_EMIT.         ( N -- )
                DUP BL 255 BETWEEN 0= IF  DROP [CHAR] .  THEN  V_EMIT ;

: V_DUMP  ( ADR LEN -- )  ( HEX BYTE FORMAT WITH ASCII )
         OVER +NO-WRAP DUP ROT
         ?DO     V_CR I 4 V_U.R  V_SPACE V_SPACE
                 I 16  +NO-WRAP OVER UMIN I
                 2DUP
                 DO      I V_C@ 2 V_H.N V_SPACE I J 7 + = IF V_SPACE THEN
                 LOOP    2DUP -  16 OVER - 3 *  SWAP 8 < -  1+ V_SPACES
                 DO      I V_C@ V_EMIT.
                 LOOP PAUSE  \  NUF? ?LEAVE
\                SCREENDELAY MS          \ SLOW DOWN OUTPUT
     16 +LOOP    DROP    ;

: V_WORDS ( -- )
\        BL V_WORD V_COUNT DUP WPAD C! WPAD 1+ SWAP CMOVE
        V_CONTEXT V_@ 0           \ LFA N
        BEGIN DUP 5 MOD  0= IF V_CR THEN
              DUP 50 =
              IF  S" NEXT LINE=<RETURN>, NEXT PAGE=<ANY>, QUIT=Q "
                  VV_TYPE
                  DROP V_KEY
                  DUP 0XD = IF   DROP 45   ELSE
                  UPC 'Q' = IF   DROP EXIT ELSE
                        0  THEN THEN   V_CR
              THEN  1+ SWAP
        DUP V_W@ TUCK u> 0= if pause then  ?DUP
        WHILE DUP V_LINK>N V_.ID 9 V_EMIT  SWAP
        REPEAT DROP ;



' V_.ID         BUILD> .ID
' V_.NAME       BUILD> .NAME
' V_DUMP        BUILD> DUMP
' V_HERE        BUILD> HERE
' V_WORDS       BUILD> WORDS

' V_TYPE   BUILD> TYPE
' V_EMIT   BUILD> EMIT
' V_KEY    BUILD> KEY
' V_KEY?   BUILD> KEY?

' V_C,  BUILD> C,
' V_W,  BUILD> W,
' V_,   BUILD> ,

' V_BEGIN       BUILD> BEGIN    V_IMMEDIATE
' V_UNTIL       BUILD> UNTIL    V_IMMEDIATE
' V_AGAIN       BUILD> AGAIN    V_IMMEDIATE
' V_IF          BUILD> IF       V_IMMEDIATE
' V_AHEAD       BUILD> AHEAD    V_IMMEDIATE
' V_REPEAT      BUILD> REPEAT   V_IMMEDIATE
' V_THEN        BUILD> THEN     V_IMMEDIATE
' V_ELSE        BUILD> ELSE     V_IMMEDIATE
' V_WHILE       BUILD> WHILE    V_IMMEDIATE

' V_CASE        BUILD> CASE     V_IMMEDIATE
' V_OF          BUILD> OF       V_IMMEDIATE
' V_ENDOF       BUILD> ENDOF    V_IMMEDIATE
' V_ENDCASE     BUILD> ENDCASE  V_IMMEDIATE

' V_LEAVE       BUILD> LEAVE
' V_?LEAVE      BUILD> ?LEAVE
' V_DO          BUILD> DO       V_IMMEDIATE
' V_LOOP        BUILD> LOOP     V_IMMEDIATE
' V_+LOOP       BUILD> +LOOP    V_IMMEDIATE
' V_I   BUILD> I
' V_J   BUILD> J
' V_K   BUILD> K

' V_>NAME       BUILD> >NAME
' V_NAME>       BUILD> NAME>
' V_>LINK       BUILD> >LINK
' V_LINK>       BUILD> LINK>
' V_N>LINK      BUILD> N>LINK
' V_LINK>N      BUILD> LINK>N
' V_>BODY       BUILD> >BODY
' V_BODY>       BUILD> BODY>

' V_RECURSE     BUILD> RECURSE

' V_CONTEXT     BUILD> CONTEXT
' V_CURRENT     BUILD> CURRENT

' V_CMOVE>      BUILD> CMOVE>
' V_CMOVE       BUILD> CMOVE
' V_MOVE        BUILD> MOVE
' V_FILL        BUILD> FILL
' V_ERASE       BUILD> ERASE
' V_BLANK       BUILD> BLANK

' V_ORDER       BUILD> ORDER
' V_VOCS        BUILD> VOCS
' V_.VOC        BUILD> .VOC

: V_PN  V_BASE V_@ SWAP V_DECIMAL 0 V_U.R V_BASE V_! ;
: V_;PN   [CHAR] ; V_EMIT V_PN ;
: V_ESC[  27 V_EMIT [CHAR] [ V_EMIT ;
: V_AT-XY 1+ SWAP 1+ SWAP V_ESC[ V_PN V_;PN [CHAR] H V_EMIT ;
: V_PAGE  V_ESC[ S" 2J" *V_TYPE* PERFORM 0 0 V_AT-XY ;

' V_PN  BUILD> PN
' V_;PN BUILD> ;PN
' V_ESC[        BUILD> ESC[
' V_AT-XY       BUILD> AT-XY
' V_PAGE        BUILD> PAGE
' drop          BUILD> MS

' abort          BUILD> XXX

 400 constant stack-saze

: V_STAPS  ( -- )
 BEGIN  V_IP @ 2 V_IP +! V_W@ V_EXECUTE 
        DEPTH stack-saze U> abort" stack error"
 AGAIN ;


: V_(PSEE) V_W@ DUP
    V_LAST_CALL U<
    IF   ['] TYPE >IS @ >R
         ['] EMIT >IS @ >R
         ['] CR   >IS @ >R
         ['] VV_TYPE IS TYPE
         ['] V_EMIT  IS EMIT
         ['] V_CR    IS CR
        CELLS CALL-TAB + @ (SEE) \  PERFORM
         R> IS CR
         R> IS EMIT
         R> IS TYPE
    ELSE S" ONT PRIMITIV" *V_TYPE* PERFORM
    THEN ;

: V_PSEE  V_' ( V_?THROW ?EXIT ) V_(PSEE)
;
: V_.ADR ( ADR -- )
          V_U.  9 V_EMIT ;
0 VALUE NOT_LAST
: V_OP.   2+ DUP V_W@ 9 V_EMIT V_U. ;
: V_BR.   V_OP.  DUP V_W@ NOT_LAST  UMAX  TO NOT_LAST ;
: V_OP"   2+ DUP V_COUNT tuck 9 V_EMIT V_TYPE + 1- ;
: V_?@=  ( ADDR CFA -- ADDR FLAG )
         OVER V_W@ = ;

' V_(PSEE)  BUILD> (PSEE)
' V_PSEE  BUILD> PSEE
: V_ASEE  ( ADR -- )
        DUP
        TO NOT_LAST
        BEGIN  V_CR 2+ DUP V_.ADR  DUP V_W@ V_>NAME DUP
                IF V_.ID
                ELSE DROP DUP V_W@ V_U.
                THEN DUP V_W@
                case
 'V_(C")        OF V_OP" ENDOF
 'V_(S")        OF V_OP" ENDOF
 'V_(.")        OF V_OP" ENDOF
 'V_(ABORT")    OF V_OP" ENDOF

 'V_DOLIT       OF 2+ DUP V_@ 9 V_EMIT V_. CELL+ 2- ENDOF

 'V_(DO)        OF V_BR. ENDOF
 'V_(?DO)       OF V_BR. ENDOF
 'V_(LOOP)      OF V_OP. ENDOF
 'V_(+LOOP)     OF V_OP. ENDOF

 'V_BRANCH      OF V_BR. dup dup v_w@ u>
                        if DUP NOT_LAST U< NOT
                           IF DROP EXIT THEN
                        then   ENDOF
 'V_?BRANCH     OF V_BR. ENDOF
 'V__OF         OF V_BR. ENDOF

 'V_EXIT        OF DUP NOT_LAST U< NOT
                         IF DROP EXIT THEN ENDOF
                endcase
        DUP V_HERE U>  V_KEY?
        IF V_KEY  27 =  OR
        THEN         \ NUF?
        UNTIL DROP ;

: V_SEE  ( -- \ <WORD> )
    V_' V_CR  DUP V_W@
   DUP      'V_DOCOL =
   IF DROP V_ASEE EXIT
   THEN
   DUP      'V_DOCON =
   IF DROP DUP V_>BODY V_@ V_.
      S" CONSTANT " VV_TYPE V_.NAME EXIT
   THEN
 DUP  V_LAST_CALL U> IF NIP  S" DOES>" VV_TYPE V_CR
                        V_ASEE EXIT
   THEN
  DROP  S" PSEE" VV_TYPE V_CR V_(PSEE)
                    ;

' V_SEE  BUILD> SEE
' V_ASEE  BUILD> ASEE

' V_\   BUILD> \    v_immediate
' V_PARSE       BUILD> PARSE
' V_(   BUILD> (    v_immediate
' V_.(  BUILD> .(   v_immediate

' XOR   BUILD> XOR
' WITHIN        BUILD> WITHIN
' U<    BUILD> U<
' U>    BUILD> U>
' UM*   BUILD> UM*
' TUCK  BUILD> TUCK
' TRUE  BUILD> TRUE
' FALSE BUILD> FALSE
' SWAP  BUILD> SWAP
' 2ROT  BUILD> 2ROT
' S>D   BUILD> S>D
' RSHIFT        BUILD> RSHIFT
' ROT   BUILD> ROT
' OVER  BUILD> OVER
' OR    BUILD> OR
' NIP   BUILD> NIP
' NEGATE        BUILD> NEGATE
' MIN   BUILD> MIN
' MAX   BUILD> MAX
' M+    BUILD> M+
' M*    BUILD> M*
' LSHIFT        BUILD> LSHIFT
' INVERT        BUILD> INVERT
' DU<   BUILD> DU<
' DNEGATE       BUILD> DNEGATE
' DMIN  BUILD> DMIN
' DMAX  BUILD> DMAX
' DEPTH BUILD> DEPTH
' DABS  BUILD> DABS
' D=    BUILD> D=
' D<>   BUILD> D<>
' D<    BUILD> D<
' D2/   BUILD> D2/
' D2*   BUILD> D2*
' D0=   BUILD> D0=
' D0<   BUILD> D0<
' D-    BUILD> D-
' D+    BUILD> D+
' CHARS BUILD> CHARS
' CHAR+ BUILD> CHAR+
' V_SPAN  BUILD> SPAN

: V_CHAR          ( -- CHAR )
                BL V_WORD 1+ V_C@ ;
: v_[CHAR] V_CHAR v_lit ;
' V_CHAR  BUILD> CHAR
' V_[CHAR]  BUILD> [CHAR]       v_immediate
' AND   BUILD> AND
' ABS   BUILD> ABS
' >     BUILD> >
' 0<    BUILD> 0<
' 0<>   BUILD> 0<>
' 0>    BUILD> 0>
' 2*    BUILD> 2*
' 2/    BUILD> 2/
' 2DROP BUILD> 2DROP
' 2DUP  BUILD> 2DUP
' 2OVER BUILD> 2OVER
' 2SWAP BUILD> 2SWAP
' <     BUILD> <
' <>    BUILD> <>

' V_>IN BUILD> >IN
' V_2R@ BUILD> 2R@
' V_2R> BUILD> 2R>
' V_2>R BUILD> 2>R
' V_/MOD        BUILD> /MOD
' V_."  BUILD> ."      V_IMMEDIATE
' V_/STRING     BUILD> /STRING
' -TRAILING     BUILD> RAILING
' V_>R  BUILD> >R
' V_?DO BUILD> ?DO
' V_ABORT       BUILD> ABORT
' V_ABORT"      BUILD> ABORT"   V_IMMEDIATE
' V_COUNT       BUILD> COUNT
' V_DECIMAL     BUILD> DECIMAL
' V_IMMEDIATE   BUILD> IMMEDIATE
' V_ONLY        BUILD> ONLY
' V_PAD BUILD> PAD
' V_PREVIOUS    BUILD> PREVIOUS
' V_QUERY       BUILD> QUERY
' V_R>  BUILD> R>
' V_R@  BUILD> R@
' V_S"  BUILD> S"       V_IMMEDIATE
' V_C"  BUILD> C"       V_IMMEDIATE
' V_SOURCE      BUILD> SOURCE
' V_SPACE       BUILD> SPACE
' V_SPACES      BUILD> SPACES
' V_THROW       BUILD> THROW
' V_TIB BUILD> TIB
' V_ALLOT       BUILD> ALLOT
: v_.S            ( -- )
                ?STACK
                DEPTH .SMAX @ MIN DUP
                IF      s" ["  VV_TYPE
                        DEPTH 1- 1 v_.R
                        s" ] " VV_TYPE
                        BEGIN   DUP PICK 1 v_.R
                                v_SPACE
                                1- DUP 0=
                        UNTIL
                ELSE    s"  empty " VV_TYPE
                THEN    DROP ;


' V_.S   BUILD> .S

: v_COMPARE   ( adr1 len1 adr2 len2 -- n )
      "V> 2swap  "V> 2swap COMPARE ;
: v_PICK DEPTH umin PICK ;
: v_ROLL DEPTH umin ROLL ;


' v_ROLL        BUILD> ROLL
' v_PICK        BUILD> PICK
' V_['] BUILD> [']     V_IMMEDIATE
' V_TO  BUILD> TO      V_IMMEDIATE
' V_[compile]   BUILD> [COMPILE]  V_IMMEDIATE
' v_POSTPONE    BUILD> POSTPONE   V_IMMEDIATE
' v_LIT BUILD> LITERAL            V_IMMEDIATE
' v_2LITERAL BUILD> 2LITERAL      V_IMMEDIATE
' v_COMPARE     BUILD> COMPARE
' V_ACCEPT      BUILD> ACCEPT
' v_UNLOOP      BUILD> UNLOOP
' v_GET-CURRENT BUILD> GET-CURRENT
' v_SET-CURRENT BUILD> SET-CURRENT
' TIME&DATE   BUILD> TIME&DATE
' v_EXPECT      BUILD> EXPECT

: VV>_P  ( VV_ADDR -- ADDR )
       ROM_SIZE - DUP RAM_SIZE U<
       IF  RAM +  EXIT THEN
       ABORT" PROTECT ERROR " ;

: V>_P   (  V_ADDR -- ADDR )
       DUP ROM_SIZE U<  IF ROM +  EXIT THEN
       VV>_P ;

: "V>_P   (  V_ADDR N -- ADDR )
      dup 0< ABORT" PROTECT ERROR "
      2dup + dup ROM_SIZE U<
      IF drop swap ROM + swap EXIT
      THEN
      ROM_SIZE - RAM_SIZE U<
      IF  swap VV>_P swap exit THEN
      ABORT" PROTECT ERROR " ;

: VFM_PUSK
    BEGIN ['] V_STAPS MINI-CATCH
    AGAIN  ;

: PUSK
 'V_QUIT 2+  V_IP !
  V_DECIMAL
  VFM_PUSK
;

: "TYPE,        HERE >R
                [CHAR] " PARSE
                DUP 2+ ALLOT
                R> SWAP MOVE
                CRLF$ COUNT HERE SWAP - 2 MOVE
;

CREATE AHELLO HERE
"TYPE, VIRTUAL FORTH MACHINE
"TYPE, WORDS          LOOK FOR WORDS IN THE DICTIONARY
"TYPE,  SEE   <WORD>   DECOMPILE <WORD> TO THE SCREEN.
"TYPE, PSEE   <WORD>   FOR PRIMITIVE OF THE 2ND LEVEL

 HERE - NEGATE CONSTANT LHELLO
: V_HELLO AHELLO LHELLO VV_TYPE ;

: V_COLD
 [ RAM ] LITERAL RAM VHERE ROM_SIZE - CMOVE
  'V_QUIT 2+  V_IP !
 ;

' V_COLD        BUILD> COLD

   '  V>_P IS  V>
   ' "V>_P IS "V>
   ' VV>_P IS VV>
   VHERE V_DP V_!
   V_DECIMAL
\S
 >NUMBER
ALIGN ALIGNED ALLOCATE CASE
CONVERT CS-PICK CS-ROLL EKEY EKEY>CHAR EKEY? ENDCASE
ENDOF ENVIRONMENT? EVALUATE FORGET FORTH-WORDLIST
FREE  GET-ORDER  LOCALS|  MARKER
MS OF  REFILL RESIZE RESTORE-INPUT
SEARCH SEARCH-WORDLIST  SET-ORDER SLITERAL
SOURCE-ID  TO  UNUSED VALUE
WORDLIST  [ELSE] [IF] [THEN]

